~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/scripts/link-vmlinux.sh

Version: ~ [ linux-6.11.5 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.58 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.114 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.169 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.228 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.284 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.322 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.9 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

Diff markup

Differences between /scripts/link-vmlinux.sh (Version linux-6.11.5) and /scripts/link-vmlinux.sh (Version linux-5.8.18)


  1 #!/bin/sh                                           1 #!/bin/sh
  2 # SPDX-License-Identifier: GPL-2.0                  2 # SPDX-License-Identifier: GPL-2.0
  3 #                                                   3 #
  4 # link vmlinux                                      4 # link vmlinux
  5 #                                                   5 #
  6 # vmlinux is linked from the objects in vmlinu !!   6 # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
  7 # vmlinux.a contains objects that are linked u !!   7 # $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
                                                   >>   8 # in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
  8 # $(KBUILD_VMLINUX_LIBS) are archives which ar      9 # $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
  9 # (not within --whole-archive), and do not req     10 # (not within --whole-archive), and do not require symbol indexes added.
 10 #                                                  11 #
 11 # vmlinux                                          12 # vmlinux
 12 #   ^                                              13 #   ^
 13 #   |                                              14 #   |
 14 #   +--< vmlinux.a                             !!  15 #   +--< $(KBUILD_VMLINUX_OBJS)
                                                   >>  16 #   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
 15 #   |                                              17 #   |
 16 #   +--< $(KBUILD_VMLINUX_LIBS)                    18 #   +--< $(KBUILD_VMLINUX_LIBS)
 17 #   |    +--< lib/lib.a + more                     19 #   |    +--< lib/lib.a + more
 18 #   |                                              20 #   |
 19 #   +-< ${kallsymso} (see description in KALLS     21 #   +-< ${kallsymso} (see description in KALLSYMS section)
 20 #                                                  22 #
 21 # vmlinux version (uname -v) cannot be updated     23 # vmlinux version (uname -v) cannot be updated during normal
 22 # descending-into-subdirs phase since we do no     24 # descending-into-subdirs phase since we do not yet know if we need to
 23 # update vmlinux.                                  25 # update vmlinux.
 24 # Therefore this step is delayed until just be     26 # Therefore this step is delayed until just before final link of vmlinux.
 25 #                                                  27 #
 26 # System.map is generated to document addresse     28 # System.map is generated to document addresses of all kernel symbols
 27                                                    29 
 28 # Error out on error                               30 # Error out on error
 29 set -e                                             31 set -e
 30                                                    32 
 31 LD="$1"                                        << 
 32 KBUILD_LDFLAGS="$2"                            << 
 33 LDFLAGS_vmlinux="$3"                           << 
 34                                                << 
 35 is_enabled() {                                 << 
 36         grep -q "^$1=y" include/config/auto.co << 
 37 }                                              << 
 38                                                << 
 39 # Nice output in kbuild format                     33 # Nice output in kbuild format
 40 # Will be supressed by "make -s"                   34 # Will be supressed by "make -s"
 41 info()                                             35 info()
 42 {                                                  36 {
 43         printf "  %-7s %s\n" "${1}" "${2}"     !!  37         if [ "${quiet}" != "silent_" ]; then
                                                   >>  38                 printf "  %-7s %s\n" "${1}" "${2}"
                                                   >>  39         fi
                                                   >>  40 }
                                                   >>  41 
                                                   >>  42 # Link of vmlinux.o used for section mismatch analysis
                                                   >>  43 # ${1} output file
                                                   >>  44 modpost_link()
                                                   >>  45 {
                                                   >>  46         local objects
                                                   >>  47 
                                                   >>  48         objects="--whole-archive                                \
                                                   >>  49                 ${KBUILD_VMLINUX_OBJS}                          \
                                                   >>  50                 --no-whole-archive                              \
                                                   >>  51                 --start-group                                   \
                                                   >>  52                 ${KBUILD_VMLINUX_LIBS}                          \
                                                   >>  53                 --end-group"
                                                   >>  54 
                                                   >>  55         ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
                                                   >>  56 }
                                                   >>  57 
                                                   >>  58 objtool_link()
                                                   >>  59 {
                                                   >>  60         local objtoolopt;
                                                   >>  61 
                                                   >>  62         if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then
                                                   >>  63                 objtoolopt="check"
                                                   >>  64                 if [ -z "${CONFIG_FRAME_POINTER}" ]; then
                                                   >>  65                         objtoolopt="${objtoolopt} --no-fp"
                                                   >>  66                 fi
                                                   >>  67                 if [ -n "${CONFIG_GCOV_KERNEL}" ]; then
                                                   >>  68                         objtoolopt="${objtoolopt} --no-unreachable"
                                                   >>  69                 fi
                                                   >>  70                 if [ -n "${CONFIG_RETPOLINE}" ]; then
                                                   >>  71                         objtoolopt="${objtoolopt} --retpoline"
                                                   >>  72                 fi
                                                   >>  73                 if [ -n "${CONFIG_X86_SMAP}" ]; then
                                                   >>  74                         objtoolopt="${objtoolopt} --uaccess"
                                                   >>  75                 fi
                                                   >>  76                 info OBJTOOL ${1}
                                                   >>  77                 tools/objtool/objtool ${objtoolopt} ${1}
                                                   >>  78         fi
 44 }                                                  79 }
 45                                                    80 
 46 # Link of vmlinux                                  81 # Link of vmlinux
 47 # ${1} - output file                               82 # ${1} - output file
                                                   >>  83 # ${2}, ${3}, ... - optional extra .o files
 48 vmlinux_link()                                     84 vmlinux_link()
 49 {                                                  85 {
                                                   >>  86         local lds="${objtree}/${KBUILD_LDS}"
 50         local output=${1}                          87         local output=${1}
 51         local objs                             !!  88         local objects
 52         local libs                             !!  89         local strip_debug
 53         local ld                               << 
 54         local ldflags                          << 
 55         local ldlibs                           << 
 56                                                    90 
 57         info LD ${output}                          91         info LD ${output}
 58                                                    92 
 59         # skip output file argument                93         # skip output file argument
 60         shift                                      94         shift
 61                                                    95 
 62         if is_enabled CONFIG_LTO_CLANG || is_e << 
 63                 # Use vmlinux.o instead of per << 
 64                 objs=vmlinux.o                 << 
 65                 libs=                          << 
 66         else                                   << 
 67                 objs=vmlinux.a                 << 
 68                 libs="${KBUILD_VMLINUX_LIBS}"  << 
 69         fi                                     << 
 70                                                << 
 71         if is_enabled CONFIG_MODULES; then     << 
 72                 objs="${objs} .vmlinux.export. << 
 73         fi                                     << 
 74                                                << 
 75         objs="${objs} init/version-timestamp.o << 
 76                                                << 
 77         if [ "${SRCARCH}" = "um" ]; then       << 
 78                 wl=-Wl,                        << 
 79                 ld="${CC}"                     << 
 80                 ldflags="${CFLAGS_vmlinux}"    << 
 81                 ldlibs="-lutil -lrt -lpthread" << 
 82         else                                   << 
 83                 wl=                            << 
 84                 ld="${LD}"                     << 
 85                 ldflags="${KBUILD_LDFLAGS} ${L << 
 86                 ldlibs=                        << 
 87         fi                                     << 
 88                                                << 
 89         ldflags="${ldflags} ${wl}--script=${ob << 
 90                                                << 
 91         # The kallsyms linking does not need d     96         # The kallsyms linking does not need debug symbols included.
 92         if [ -n "${strip_debug}" ] ; then      !!  97         if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
 93                 ldflags="${ldflags} ${wl}--str !!  98                 strip_debug=-Wl,--strip-debug
 94         fi                                         99         fi
 95                                                   100 
 96         if is_enabled CONFIG_VMLINUX_MAP; then !! 101         if [ "${SRCARCH}" != "um" ]; then
 97                 ldflags="${ldflags} ${wl}-Map= !! 102                 objects="--whole-archive                        \
                                                   >> 103                         ${KBUILD_VMLINUX_OBJS}                  \
                                                   >> 104                         --no-whole-archive                      \
                                                   >> 105                         --start-group                           \
                                                   >> 106                         ${KBUILD_VMLINUX_LIBS}                  \
                                                   >> 107                         --end-group                             \
                                                   >> 108                         ${@}"
                                                   >> 109 
                                                   >> 110                 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}      \
                                                   >> 111                         ${strip_debug#-Wl,}                     \
                                                   >> 112                         -o ${output}                            \
                                                   >> 113                         -T ${lds} ${objects}
                                                   >> 114         else
                                                   >> 115                 objects="-Wl,--whole-archive                    \
                                                   >> 116                         ${KBUILD_VMLINUX_OBJS}                  \
                                                   >> 117                         -Wl,--no-whole-archive                  \
                                                   >> 118                         -Wl,--start-group                       \
                                                   >> 119                         ${KBUILD_VMLINUX_LIBS}                  \
                                                   >> 120                         -Wl,--end-group                         \
                                                   >> 121                         ${@}"
                                                   >> 122 
                                                   >> 123                 ${CC} ${CFLAGS_vmlinux}                         \
                                                   >> 124                         ${strip_debug}                          \
                                                   >> 125                         -o ${output}                            \
                                                   >> 126                         -Wl,-T,${lds}                           \
                                                   >> 127                         ${objects}                              \
                                                   >> 128                         -lutil -lrt -lpthread
                                                   >> 129                 rm -f linux
 98         fi                                        130         fi
 99                                                << 
100         ${ld} ${ldflags} -o ${output}          << 
101                 ${wl}--whole-archive ${objs} $ << 
102                 ${wl}--start-group ${libs} ${w << 
103                 ${kallsymso} ${btf_vmlinux_bin << 
104 }                                                 131 }
105                                                   132 
106 # generate .BTF typeinfo from DWARF debuginfo     133 # generate .BTF typeinfo from DWARF debuginfo
107 # ${1} - vmlinux image                            134 # ${1} - vmlinux image
                                                   >> 135 # ${2} - file to dump raw BTF data into
108 gen_btf()                                         136 gen_btf()
109 {                                                 137 {
110         local pahole_ver                          138         local pahole_ver
111         local btf_data=${1}.btf.o              << 
112                                                   139 
113         if ! [ -x "$(command -v ${PAHOLE})" ];    140         if ! [ -x "$(command -v ${PAHOLE})" ]; then
114                 echo >&2 "BTF: ${1}: pahole ($    141                 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
115                 return 1                          142                 return 1
116         fi                                        143         fi
117                                                   144 
118         pahole_ver=$(${PAHOLE} --version | sed    145         pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
119         if [ "${pahole_ver}" -lt "116" ]; then    146         if [ "${pahole_ver}" -lt "116" ]; then
120                 echo >&2 "BTF: ${1}: pahole ve    147                 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
121                 return 1                          148                 return 1
122         fi                                        149         fi
123                                                   150 
124         info BTF "${btf_data}"                 !! 151         vmlinux_link ${1}
125         LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J << 
126                                                   152 
127         # Create ${btf_data} which contains ju !! 153         info "BTF" ${2}
                                                   >> 154         LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
                                                   >> 155 
                                                   >> 156         # Create ${2} which contains just .BTF section but no symbols. Add
128         # SHF_ALLOC because .BTF will be part     157         # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
129         # deletes all symbols including __star    158         # deletes all symbols including __start_BTF and __stop_BTF, which will
130         # be redefined in the linker script. A    159         # be redefined in the linker script. Add 2>/dev/null to suppress GNU
131         # objcopy warnings: "empty loadable se    160         # objcopy warnings: "empty loadable segment detected at ..."
132         ${OBJCOPY} --only-section=.BTF --set-s    161         ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
133                 --strip-all ${1} "${btf_data}" !! 162                 --strip-all ${1} ${2} 2>/dev/null
134         # Change e_type to ET_REL so that it c    163         # Change e_type to ET_REL so that it can be used to link final vmlinux.
135         # GNU ld 2.35+ and lld do not allow an !! 164         # Unlike GNU ld, lld does not allow an ET_EXEC input.
136         if is_enabled CONFIG_CPU_BIG_ENDIAN; t !! 165         printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
137                 et_rel='\0\1'                  << 
138         else                                   << 
139                 et_rel='\1\0'                  << 
140         fi                                     << 
141         printf "${et_rel}" | dd of="${btf_data << 
142                                                << 
143         btf_vmlinux_bin_o=${btf_data}          << 
144 }                                                 166 }
145                                                   167 
146 # Create ${2}.o file with all symbols from the !! 168 # Create ${2} .o file with all symbols from the ${1} object file
147 kallsyms()                                        169 kallsyms()
148 {                                                 170 {
                                                   >> 171         info KSYM ${2}
149         local kallsymopt;                         172         local kallsymopt;
150                                                   173 
151         if is_enabled CONFIG_KALLSYMS_ALL; the !! 174         if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
152                 kallsymopt="${kallsymopt} --al    175                 kallsymopt="${kallsymopt} --all-symbols"
153         fi                                        176         fi
154                                                   177 
155         if is_enabled CONFIG_KALLSYMS_ABSOLUTE !! 178         if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
156                 kallsymopt="${kallsymopt} --ab    179                 kallsymopt="${kallsymopt} --absolute-percpu"
157         fi                                        180         fi
158                                                   181 
159         info KSYMS "${2}.S"                    !! 182         if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
160         scripts/kallsyms ${kallsymopt} "${1}"  !! 183                 kallsymopt="${kallsymopt} --base-relative"
                                                   >> 184         fi
                                                   >> 185 
                                                   >> 186         local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL}               \
                                                   >> 187                       ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
161                                                   188 
162         info AS "${2}.o"                       !! 189         local afile="`basename ${2} .o`.S"
163         ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE << 
164               ${KBUILD_AFLAGS} ${KBUILD_AFLAGS << 
165                                                   190 
166         kallsymso=${2}.o                       !! 191         ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
                                                   >> 192         ${CC} ${aflags} -c -o ${2} ${afile}
167 }                                                 193 }
168                                                   194 
169 # Perform kallsyms for the given temporary vml !! 195 # Perform one step in kallsyms generation, including temporary linking of
170 sysmap_and_kallsyms()                          !! 196 # vmlinux.
                                                   >> 197 kallsyms_step()
171 {                                                 198 {
172         mksysmap "${1}" "${1}.syms"            !! 199         kallsymso_prev=${kallsymso}
173         kallsyms "${1}.syms" "${1}.kallsyms"   !! 200         kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
                                                   >> 201         kallsymso=${kallsyms_vmlinux}.o
174                                                   202 
175         kallsyms_sysmap=${1}.syms              !! 203         vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
                                                   >> 204         kallsyms ${kallsyms_vmlinux} ${kallsymso}
176 }                                                 205 }
177                                                   206 
178 # Create map file with all symbols from ${1}      207 # Create map file with all symbols from ${1}
179 # See mksymap for additional details              208 # See mksymap for additional details
180 mksysmap()                                        209 mksysmap()
181 {                                                 210 {
182         info NM ${2}                           !! 211         ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
183         ${NM} -n "${1}" | sed -f "${srctree}/s << 
184 }                                                 212 }
185                                                   213 
186 sorttable()                                       214 sorttable()
187 {                                                 215 {
188         ${objtree}/scripts/sorttable ${1}         216         ${objtree}/scripts/sorttable ${1}
189 }                                                 217 }
190                                                   218 
                                                   >> 219 # Delete output files in case of error
191 cleanup()                                         220 cleanup()
192 {                                                 221 {
193         rm -f .btf.*                              222         rm -f .btf.*
                                                   >> 223         rm -f .tmp_System.map
                                                   >> 224         rm -f .tmp_vmlinux*
194         rm -f System.map                          225         rm -f System.map
195         rm -f vmlinux                             226         rm -f vmlinux
196         rm -f vmlinux.map                      !! 227         rm -f vmlinux.o
                                                   >> 228 }
                                                   >> 229 
                                                   >> 230 on_exit()
                                                   >> 231 {
                                                   >> 232         if [ $? -ne 0 ]; then
                                                   >> 233                 cleanup
                                                   >> 234         fi
197 }                                                 235 }
                                                   >> 236 trap on_exit EXIT
                                                   >> 237 
                                                   >> 238 on_signals()
                                                   >> 239 {
                                                   >> 240         exit 1
                                                   >> 241 }
                                                   >> 242 trap on_signals HUP INT QUIT TERM
198                                                   243 
199 # Use "make V=1" to debug this script             244 # Use "make V=1" to debug this script
200 case "${KBUILD_VERBOSE}" in                       245 case "${KBUILD_VERBOSE}" in
201 *1*)                                              246 *1*)
202         set -x                                    247         set -x
203         ;;                                        248         ;;
204 esac                                              249 esac
205                                                   250 
206 if [ "$1" = "clean" ]; then                       251 if [ "$1" = "clean" ]; then
207         cleanup                                   252         cleanup
208         exit 0                                    253         exit 0
209 fi                                                254 fi
210                                                   255 
211 ${MAKE} -f "${srctree}/scripts/Makefile.build" !! 256 # We need access to CONFIG_ symbols
212                                                !! 257 . include/config/auto.conf
213 btf_vmlinux_bin_o=                             << 
214 kallsymso=                                     << 
215 strip_debug=                                   << 
216                                                << 
217 if is_enabled CONFIG_KALLSYMS; then            << 
218         truncate -s0 .tmp_vmlinux.kallsyms0.sy << 
219         kallsyms .tmp_vmlinux.kallsyms0.syms . << 
220 fi                                             << 
221                                                << 
222 if is_enabled CONFIG_KALLSYMS || is_enabled CO << 
223                                                << 
224         # The kallsyms linking does not need d << 
225         if ! is_enabled CONFIG_DEBUG_INFO_BTF; << 
226                 strip_debug=1                  << 
227         fi                                     << 
228                                                << 
229         vmlinux_link .tmp_vmlinux1             << 
230 fi                                             << 
231                                                   258 
232 if is_enabled CONFIG_DEBUG_INFO_BTF; then      !! 259 # Update version
233         if ! gen_btf .tmp_vmlinux1; then       !! 260 info GEN .version
                                                   >> 261 if [ -r .version ]; then
                                                   >> 262         VERSION=$(expr 0$(cat .version) + 1)
                                                   >> 263         echo $VERSION > .version
                                                   >> 264 else
                                                   >> 265         rm -f .version
                                                   >> 266         echo 1 > .version
                                                   >> 267 fi;
                                                   >> 268 
                                                   >> 269 # final build of init/
                                                   >> 270 ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
                                                   >> 271 
                                                   >> 272 #link vmlinux.o
                                                   >> 273 info LD vmlinux.o
                                                   >> 274 modpost_link vmlinux.o
                                                   >> 275 objtool_link vmlinux.o
                                                   >> 276 
                                                   >> 277 # modpost vmlinux.o to check for section mismatches
                                                   >> 278 ${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
                                                   >> 279 
                                                   >> 280 info MODINFO modules.builtin.modinfo
                                                   >> 281 ${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
                                                   >> 282 info GEN modules.builtin
                                                   >> 283 # The second line aids cases where multiple modules share the same object.
                                                   >> 284 tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
                                                   >> 285         tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
                                                   >> 286 
                                                   >> 287 btf_vmlinux_bin_o=""
                                                   >> 288 if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
                                                   >> 289         btf_vmlinux_bin_o=.btf.vmlinux.bin.o
                                                   >> 290         if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
234                 echo >&2 "Failed to generate B    291                 echo >&2 "Failed to generate BTF for vmlinux"
235                 echo >&2 "Try to disable CONFI    292                 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
236                 exit 1                            293                 exit 1
237         fi                                        294         fi
238 fi                                                295 fi
239                                                   296 
240 if is_enabled CONFIG_KALLSYMS; then            !! 297 kallsymso=""
                                                   >> 298 kallsymso_prev=""
                                                   >> 299 kallsyms_vmlinux=""
                                                   >> 300 if [ -n "${CONFIG_KALLSYMS}" ]; then
241                                                   301 
242         # kallsyms support                        302         # kallsyms support
243         # Generate section listing all symbols    303         # Generate section listing all symbols and add it into vmlinux
244         # It's a four step process:            !! 304         # It's a three step process:
245         # 0)  Generate a dummy __kallsyms with !! 305         # 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
246         # 1)  Link .tmp_vmlinux.kallsyms1 so i !! 306         #     but __kallsyms is empty.
247         #     with a dummy __kallsyms.         << 
248         #     Running kallsyms on that gives u    307         #     Running kallsyms on that gives us .tmp_kallsyms1.o with
249         #     the right size                      308         #     the right size
250         # 2)  Link .tmp_vmlinux.kallsyms2 so i !! 309         # 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
251         #     the right size, but due to the a    310         #     the right size, but due to the added section, some
252         #     addresses have shifted.             311         #     addresses have shifted.
253         #     From here, we generate a correct !! 312         #     From here, we generate a correct .tmp_kallsyms2.o
254         # 3)  That link may have expanded the     313         # 3)  That link may have expanded the kernel image enough that
255         #     more linker branch stubs / tramp    314         #     more linker branch stubs / trampolines had to be added, which
256         #     introduces new names, which furt    315         #     introduces new names, which further expands kallsyms. Do another
257         #     pass if that is the case. In the    316         #     pass if that is the case. In theory it's possible this results
258         #     in even more stubs, but unlikely    317         #     in even more stubs, but unlikely.
259         #     KALLSYMS_EXTRA_PASS=1 may also u    318         #     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
260         #     other bugs.                         319         #     other bugs.
261         # 4)  The correct ${kallsymso} is link    320         # 4)  The correct ${kallsymso} is linked into the final vmlinux.
262         #                                         321         #
263         # a)  Verify that the System.map from     322         # a)  Verify that the System.map from vmlinux matches the map from
264         #     ${kallsymso}.                       323         #     ${kallsymso}.
265                                                   324 
266         # The kallsyms linking does not need d !! 325         kallsyms_step 1
267         strip_debug=1                          !! 326         kallsyms_step 2
268                                                   327 
269         sysmap_and_kallsyms .tmp_vmlinux1      !! 328         # step 3
270         size1=$(${CONFIG_SHELL} "${srctree}/sc !! 329         size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
271                                                << 
272         vmlinux_link .tmp_vmlinux2             << 
273         sysmap_and_kallsyms .tmp_vmlinux2      << 
274         size2=$(${CONFIG_SHELL} "${srctree}/sc    330         size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
275                                                   331 
276         if [ $size1 -ne $size2 ] || [ -n "${KA    332         if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
277                 vmlinux_link .tmp_vmlinux3     !! 333                 kallsyms_step 3
278                 sysmap_and_kallsyms .tmp_vmlin << 
279         fi                                        334         fi
280 fi                                                335 fi
281                                                   336 
282 strip_debug=                                   !! 337 vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
283                                                << 
284 vmlinux_link vmlinux                           << 
285                                                << 
286 # fill in BTF IDs                              << 
287 if is_enabled CONFIG_DEBUG_INFO_BTF && is_enab << 
288         info BTFIDS vmlinux                    << 
289         ${RESOLVE_BTFIDS} vmlinux              << 
290 fi                                             << 
291                                                << 
292 mksysmap vmlinux System.map                    << 
293                                                   338 
294 if is_enabled CONFIG_BUILDTIME_TABLE_SORT; the !! 339 if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
295         info SORTTAB vmlinux                      340         info SORTTAB vmlinux
296         if ! sorttable vmlinux; then              341         if ! sorttable vmlinux; then
297                 echo >&2 Failed to sort kernel    342                 echo >&2 Failed to sort kernel tables
298                 exit 1                            343                 exit 1
299         fi                                        344         fi
300 fi                                                345 fi
301                                                   346 
                                                   >> 347 info SYSMAP System.map
                                                   >> 348 mksysmap vmlinux System.map
                                                   >> 349 
302 # step a (see comment above)                      350 # step a (see comment above)
303 if is_enabled CONFIG_KALLSYMS; then            !! 351 if [ -n "${CONFIG_KALLSYMS}" ]; then
304         if ! cmp -s System.map "${kallsyms_sys !! 352         mksysmap ${kallsyms_vmlinux} .tmp_System.map
                                                   >> 353 
                                                   >> 354         if ! cmp -s System.map .tmp_System.map; then
305                 echo >&2 Inconsistent kallsyms    355                 echo >&2 Inconsistent kallsyms data
306                 echo >&2 'Try "make KALLSYMS_E !! 356                 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
307                 exit 1                            357                 exit 1
308         fi                                        358         fi
309 fi                                                359 fi
310                                                << 
311 # For fixdep                                   << 
312 echo "vmlinux: $0" > .vmlinux.d                << 
                                                      

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php